Package com.sas.metadata.remote

# Interface Aggregation

All Superinterfaces:
  `CMetadata`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `PrimaryType`, `Remote`, `Root`

public interface Aggregation extends PrimaryType
A summary of detail data that is stored with or referred to by a cube. Aggregations support rapid and efficient answers to business questions. Developers are discouraged from creating or consuming Cube metadata directly with the SAS Open Metadata Interface. Instead, Cubes should be defined by using either SAS OLAP Cube Studio or PROC OLAP. For more information, see the documentation for SAS OLAP Cube Studio and PROC OLAP.

Attributes of Aggregation are:

- `Type`
- `Nway`

Associations of Aggregation are:

- `Levels`
- `AggregationTables`
- `OwningCube`

## Usage

To create an instance of this Aggregation, use the `factory` create methods.
Example: create a Aggregation with name "Aggregation_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     Aggregation myObject = (Aggregation) factory.createComplexMetadataObject(objectStore, "Aggregation_Object", MetadataObjects.AGGREGATION, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ASSOCIATION_AGGREGATIONTABLES_NAME`
  Constant used for the name of the AggregationTables association.
  `static final String`
  `ASSOCIATION_LEVELS_NAME`
  Constant used for the name of the Levels association.
  `static final String`
  `ASSOCIATION_OWNINGCUBE_NAME`
  Constant used for the name of the OwningCube association.
  `static final String`
  `ATTRIBUTE_NWAY_NAME`
  Constant used for the name of the Nway attribute.
  `static final String`
  `ATTRIBUTE_TYPE_NAME`
  Constant used for the name of the Type attribute.

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.PrimaryType

  `ASSOCIATION_FAVORITESCONTAINERS_NAME, ATTRIBUTE_ISHIDDEN_NAME, ATTRIBUTE_PUBLICTYPE_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `AssociationList`
  `getAggregationTables()`
  Gets the Association list of `AggregationTables`
  `AssociationList`
  `getAggregationTables(boolean fGoToServer)`
  Gets the Associationlist of `AggregationTables`
  `AssociationList`
  `getLevels()`
  Gets the AssociationList of `Levels`
  `AssociationList`
  `getLevels(boolean fGoToServer)`
  Gets the Associationlist of `Levels`
  `int`
  `getNway()`
  Gets the `int` value of `Nway`
  `int`
  `getNwayState()`
  Gets the Metadata State of `Nway`
  `Cube`
  `getOwningCube()`
  Gets the `Cube` for `OwningCube`
  `AssociationList`
  `getOwningCubes()`
  Gets the Association list of `OwningCubes`
  `AssociationList`
  `getOwningCubes(boolean fGoToServer)`
  Gets the Associationlist of `OwningCubes`
  `String`
  `getType()`
  Gets the `String` value of `Type`
  `int`
  `getTypeMaxLength()`
  Gets the maximum length of `Type`
  `int`
  `getTypeState()`
  Gets the Metadata State of `Type`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `Levels`
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `OwningCube`
  `void`
  `setAggregationTables(AssociationList list)`
  Sets the `AggregationTables` list to be `list`.
  `void`
  `setAggregationTables(AssociationList inObjects, int state)`
  Sets the entire AggregationTables list to match the passed in AssociationList, sets the state of the AggregationTables
  `void`
  `setLevels(AssociationList list)`
  Sets the `Levels` list to be `list`.
  `void`
  `setLevels(AssociationList inObjects, int state)`
  Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
  `void`
  `setNway(int inNway)`
  Sets the `Nway` value and sets the state to MetadataState.LOCAL.
  `void`
  `setNway(int inNway, int state)`
  Sets the `Nway` Metadata State.
  `void`
  `setNway(String inNway)`
  Sets the `Nway` value and sets the state to MetadataState.LOCAL.
  `void`
  `setNway(String inNway, int state)`
  Sets the `Nway` value and Metadata State.
  `void`
  `setNwayState(int state)`
  Sets the Metadata State of `Nway`.
  `void`
  `setOwningCube(Cube inObject)`
  Sets the `OwningCubes` list 0th element to be `inObject`.
  `void`
  `setOwningCubes(AssociationList list)`
  Sets the `OwningCubes` list to be `list`.
  `void`
  `setOwningCubes(AssociationList list, int state)`
  Sets the `OwningCubes` list to be `list`.
  `void`
  `setType(String inType)`
  Sets the `Type` value and sets the state to MetadataState.LOCAL.
  `void`
  `setType(String inType, int state)`
  Sets the `Type` Metadata State.
  `void`
  `setTypeState(int state)`
  Sets the Metadata State of `Type`.

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.PrimaryType

  `getFavoritesContainers, getFavoritesContainers, getIsHidden, getIsHiddenState, getPublicType, getPublicTypeMaxLength, getPublicTypeState, setFavoritesContainers, setFavoritesContainers, setIsHidden, setIsHidden, setIsHidden, setIsHidden, setIsHiddenState, setPublicType, setPublicType, setPublicTypeState`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

- ## Field Details

  - ### ATTRIBUTE_TYPE_NAME

    static final String ATTRIBUTE_TYPE_NAME
    Constant used for the name of the Type attribute.

    Type: This describes the persistence mechanism for the aggregation. Valid values are: MOLAP, ROLAP.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_NWAY_NAME

    static final String ATTRIBUTE_NWAY_NAME
    Constant used for the name of the Nway attribute.

    Nway: Set to true, this attribute indicates the aggregation is the NWAY aggregation for the cube. The default is false.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_LEVELS_NAME

    static final String ASSOCIATION_LEVELS_NAME
    Constant used for the name of the Levels association.

    Levels: The levels associated with this aggregation.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_AGGREGATIONTABLES_NAME

    static final String ASSOCIATION_AGGREGATIONTABLES_NAME
    Constant used for the name of the AggregationTables association.

    AggregationTables: The tables that contain columns used in the aggregations.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_OWNINGCUBE_NAME

    static final String ASSOCIATION_OWNINGCUBE_NAME
    Constant used for the name of the OwningCube association.

    OwningCube: The cube that contains this aggregation.

    See Also:
      - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    `OwningCube`
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `PrimaryType`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    `Levels`
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `PrimaryType`
    Specified by:
      `initializePredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getType

    String getType() throws RemoteException
    Gets the `String` value of `Type`
    Returns:
      The `Type`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getTypeState

    int getTypeState() throws RemoteException
    Gets the Metadata State of `Type`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getTypeMaxLength

    int getTypeMaxLength() throws RemoteException
    Gets the maximum length of `Type`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getNway

    int getNway() throws RemoteException
    Gets the `int` value of `Nway`
    Returns:
      The `Nway`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getNwayState

    int getNwayState() throws RemoteException
    Gets the Metadata State of `Nway`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getLevels

    AssociationList getLevels() throws RemoteException, MdException
    Gets the AssociationList of `Levels`
    Returns:
      Returns the AssociationList of `Levels` which can be of type:
      Level
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getAggregationTables

    AssociationList getAggregationTables() throws RemoteException, MdException
    Gets the Association list of `AggregationTables`
    Returns:
      The AssociationList of `AggregationTables` which can be of type:
      PhysicalTable
      WorkTable
      SecuredTable
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getOwningCubes

    AssociationList getOwningCubes() throws RemoteException, MdException
    Gets the Association list of `OwningCubes`
    Returns:
      The AssociationList of `OwningCubes` which can be of type:
      Cube
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getOwningCube

    Cube getOwningCube() throws RemoteException, MdException
    Gets the `Cube` for `OwningCube`
    Returns:
      The `Cube` ( `null` if not set ) of `OwningCube` which can be of type:
      Cube
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getLevels

    AssociationList getLevels(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `Levels`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `Levels` which can be of type:
      Level
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getAggregationTables

    AssociationList getAggregationTables(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `AggregationTables`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `AggregationTables` which can be of type:
      PhysicalTable
      WorkTable
      SecuredTable
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getOwningCubes

    AssociationList getOwningCubes(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `OwningCubes`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `OwningCubes` which can be of type:
      Cube
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### setType

    void setType(String inType) throws RemoteException
    Sets the `Type` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inType` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setType

    void setType(String inType, int state) throws RemoteException
    Sets the `Type` Metadata State.
    Parameters:
      `inType` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setTypeState

    void setTypeState(int state) throws RemoteException
    Sets the Metadata State of `Type`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setNway

    void setNway(int inNway) throws RemoteException
    Sets the `Nway` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inNway` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setNway

    void setNway(int inNway, int state) throws RemoteException
    Sets the `Nway` Metadata State.
    Parameters:
      `inNway` - int
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setNway

    void setNway(String inNway) throws RemoteException
    Sets the `Nway` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inNway` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setNway

    void setNway(String inNway, int state) throws RemoteException
    Sets the `Nway` value and Metadata State.
    Parameters:
      `inNway` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setNwayState

    void setNwayState(int state) throws RemoteException
    Sets the Metadata State of `Nway`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setLevels

    void setLevels(AssociationList list) throws RemoteException
    Sets the `Levels` list to be `list`. Objects of which can be of type:
    Level
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setLevels

    void setLevels(AssociationList inObjects, int state) throws RemoteException
    Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAggregationTables

    void setAggregationTables(AssociationList list) throws RemoteException
    Sets the `AggregationTables` list to be `list`. Objects of which can be of type:
    PhysicalTable
    WorkTable
    SecuredTable
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAggregationTables

    void setAggregationTables(AssociationList inObjects, int state) throws RemoteException
    Sets the entire AggregationTables list to match the passed in AssociationList, sets the state of the AggregationTables
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setOwningCubes

    void setOwningCubes(AssociationList list) throws RemoteException
    Sets the `OwningCubes` list to be `list`. Objects of which can be of type:
    Cube
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setOwningCubes

    void setOwningCubes(AssociationList list, int state) throws RemoteException
    Sets the `OwningCubes` list to be `list`. Objects of which can be of type:
    Cube
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setOwningCube

    void setOwningCube(Cube inObject) throws RemoteException
    Sets the `OwningCubes` list 0th element to be `inObject`.
    Parameters:
      `inObject` - Cube
    Throws:
      `RemoteException` - If error communicating with remote object.